const aria2c = require("../src/utils/aria2c");

const downloadUrl = "https://repo.anaconda.com/miniconda/Miniconda3-py39_23.3.1-0-Windows-x86_64.exe";
// 查看版本
const testGetVersion = async () => {
  await aria2c.start();
  const version = await aria2c.getVersion();
  console.log("版本：", version);
};
// 关闭aria2c
const testClose = async () => {
  await aria2c.close();
  console.log("关闭成功");
};
// 测试启动失败
const testStartFail = async () => {
  try {
    aria2c.port = 8080;
    await aria2c.start(false);
    console.log("失败");
  } catch (e) {
    console.log("测试启动失败通过：", e);
  }
};
// 测试链接aria2c失败
const testConnectFail = async () => {
  let port;
  try {
    await aria2c.start();
    port = aria2c.port;
    aria2c.port = 3306;
    await aria2c.download(downloadUrl, "./");
  } catch (e) {
    console.log("测试链接aria2c失败通过：", e);
  }
  aria2c.port = port;
};

// 测试下载
const testDownload = async () => {
  await aria2c.download(downloadUrl, "../", (res) => {
    console.log(res);
    if (res.percent > 1) {
      aria2c.close();
    }
  });
};
const run = async () => {
  await testGetVersion();
  await testClose();
  await testStartFail();
  await testConnectFail();
  await testDownload();
};

run();
